diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 6706e3f2a..8b159ac28 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -847,26 +659,27 @@ public class RenderGlobal
             }
 
             t.draw();
-            GL11.glPopMatrix();
-            GL11.glShadeModel(GL_FLAT);
+            GLRenderer.popFrame();
         }
-        GL11.glEnable(GL_TEXTURE_2D);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE);
-        GL11.glPushMatrix();
+        GLRenderer.popFrame();
+
+        GLRenderer.pushFrame();
+        GLRenderer.setDepthMask(false);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE);
         float sunAlpha = 1.0F - (this.world.getCurrentWeather() != null && this.world.getCurrentWeather() != Weathers.OVERWORLD_CLEAR ? (this.world.weatherManager.getWeatherIntensity() * this.world.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
 
         float x = 0.0F;
         float y = 0.0F;
         float z = 0.0F;
 
-        GL11.glTranslatef(x, y, z);
-        GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
-        GL11.glRotatef(celestialAngle * 360F, 0.0F, 0.0F, 1.0F);
+        GLRenderer.modelM4f().translate(x, y, z);
+        GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(celestialAngle * 360F));
 
         // Render sun
         float size = 30F;
         this.textureManager.loadTexture("/assets/minecraft/textures/terrain/sun.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-size, 100D, -size, 0.0D, 0.0D);
         t.addVertexWithUV(size, 100D, -size, 1.0D, 0.0D);
@@ -930,7 +743,7 @@ public class RenderGlobal
                 size = 200F - i * 4;
                 int color = HSBtoRGB(i / (float) iterations, 1, (float) (0.3f * this.rainbowBrightness));
                 float rainbowAlpha = (float) ((0.35f - (0.15f * Math.abs(i - iterations / 2) / (iterations / 2f))) * this.rainbowBrightness);
-                t.setColorRGBA_F(Color.redFromInt(color) / 255f, Color.greenFromInt(color) / 255f, Color.blueFromInt(color) / 255f, rainbowAlpha);
+                t.setColor4f(Color.redFromInt(color) / 255f, Color.greenFromInt(color) / 255f, Color.blueFromInt(color) / 255f, rainbowAlpha);
                 t.addVertexWithUV(-size, -100D, size, 1.0D, 1.0D);
                 t.addVertexWithUV(size, -100D, size, 0.0D, 1.0D);
                 t.addVertexWithUV(size, -100D, -size, 0.0D, 0.0D);
@@ -944,7 +757,7 @@ public class RenderGlobal
         // Render moon
         size = 20F;
         this.textureManager.loadTexture("/assets/minecraft/textures/terrain/moon.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-size, -100D, size, 1.0D, 1.0D);
         t.addVertexWithUV(size, -100D, size, 0.0D, 1.0D);
@@ -952,25 +765,14 @@ public class RenderGlobal
         t.addVertexWithUV(-size, -100D, -size, 1.0D, 0.0D);
         t.draw();
 
-        float f17 = this.world.getStarBrightness(partialTick) * sunAlpha;
-        if (f17 > 0.0F) {
+        float starVis = this.world.getStarBrightness(partialTick) * sunAlpha * sunAlpha * sunAlpha;
+        if (starVis > 0.0F) {
             this.textureManager.loadTexture("/assets/minecraft/textures/colormap/stars/default.png").bind();
-            GL11.glColor4f(f17, f17, f17, f17);
-            GL11.glCallList(this.starList);
-        }
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glEnable(GL11.GL_ALPHA_TEST);
-        GL11.glEnable(GL11.GL_FOG);
-        GL11.glPopMatrix();
-        if (worldTypeFX.hasGround()) {
-            GL11.glColor3f(r * 0.2F + 0.04F, g * 0.2F + 0.04F, b * 0.6F + 0.1F);
-        } else {
-            GL11.glColor3f(r, g, b);
+            GLRenderer.setColor4f(starVis, starVis, starVis, starVis);
+            GLRenderer.render(this.starBuffer);
         }
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        GL11.glDepthMask(true);
+        GLRenderer.popFrame();
+
     }
 
     private float getCloudHeightModifier() {
@@ -989,21 +791,24 @@ public class RenderGlobal
             renderCloudsFancy(partialTick);
             return;
         }
-        GL11.glDisable(GL11.GL_CULL_FACE);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.CLOUDS);
+        GLRenderer.setLightmapCoord2i(15, 15);
+        GLRenderer.disableState(State.CULL_FACE);
         float cameraY = (float) this.mc.activeCamera.getY(partialTick);
         byte cloudRadius = 32;
         int i = 256 / cloudRadius;
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         this.textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         Vector3fc dimensionColor = this.world.getDimensionColor(this.mc.activeCamera, partialTick);
         float r = dimensionColor.x();
         float g = dimensionColor.y();
         float b = dimensionColor.z();
         float f6 = 1f / 2048f;
-        double posX = this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F);
-        double posZ = this.mc.activeCamera.getZ(partialTick) + (double) ((this.lastCloudOffsetZ + (this.cloudOffsetZ - this.lastCloudOffsetZ) * partialTick) * 0.03F);
+        double posX = this.mc.activeCamera.getX(partialTick) + (double) (org.joml.Math.lerp(this.lastCloudOffsetX, this.cloudOffsetX, partialTick) * 0.03F);
+        double posZ = this.mc.activeCamera.getZ(partialTick) + (double) (org.joml.Math.lerp(this.lastCloudOffsetZ, this.cloudOffsetZ, partialTick) * 0.03F);
         int j = MathHelper.floor(posX / 2048D);
         int k = MathHelper.floor(posZ / 2048D);
         posX -= j * 2048;
@@ -1012,24 +817,31 @@ public class RenderGlobal
         float f10 = (float) (posX * (double) f6);
         float f11 = (float) (posZ * (double) f6);
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_F(r, g, b, 0.8F);
-        for (int cloudX = -cloudRadius * i; cloudX < cloudRadius * i; cloudX += cloudRadius) {
-            for (int cloudZ = -cloudRadius * i; cloudZ < cloudRadius * i; cloudZ += cloudRadius) {
-                tessellator.addVertexWithUV(cloudX, cloudHeight, cloudZ + cloudRadius, (float) (cloudX) * f6 + f10, (float) (cloudZ + cloudRadius) * f6 + f11);
-                tessellator.addVertexWithUV(cloudX + cloudRadius, cloudHeight, cloudZ + cloudRadius, (float) (cloudX + cloudRadius) * f6 + f10, (float) (cloudZ + cloudRadius) * f6 + f11);
-                tessellator.addVertexWithUV(cloudX + cloudRadius, cloudHeight, cloudZ, (float) (cloudX + cloudRadius) * f6 + f10, (float) (cloudZ) * f6 + f11);
-                tessellator.addVertexWithUV(cloudX, cloudHeight, cloudZ, (float) (cloudX) * f6 + f10, (float) (cloudZ) * f6 + f11);
-            }
-
-        }
-
+        tessellator.setColor4f(r, g, b, 0.8F);
+        int dist = (cloudRadius * i * 2);
+        int cloudZ = -cloudRadius * i;
+        int cloudX = -cloudRadius * i;
+        tessellator.addVertexWithUV(
+            cloudX, cloudHeight, cloudZ + cloudRadius * dist,
+            cloudX * f6 + f10, (cloudZ + cloudRadius * dist) * f6 + f11);
+        tessellator.addVertexWithUV(
+            cloudX + cloudRadius * dist, cloudHeight, cloudZ + cloudRadius * dist,
+            (cloudX + cloudRadius * dist) * f6 + f10, (cloudZ + cloudRadius * dist) * f6 + f11);
+        tessellator.addVertexWithUV(
+            cloudX + cloudRadius * dist, cloudHeight, cloudZ,
+            (cloudX + cloudRadius * dist) * f6 + f10, cloudZ * f6 + f11);
+        tessellator.addVertexWithUV(
+            cloudX, cloudHeight, cloudZ,
+            (cloudX) * f6 + f10, cloudZ * f6 + f11);
         tessellator.draw();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glEnable(GL11.GL_CULL_FACE);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.popFrame();
     }
 
     public void renderCloudsFancy(float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.setLightmapCoord2i(15, 15);
         WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(this.mc.currentWorld.getWorldType());
         this.mc.renderer.beginRenderClouds(partialTick);
 
@@ -1048,9 +860,9 @@ public class RenderGlobal
         final float gDim = dimensionColor.y();
         final float bDim = dimensionColor.z();
 
-        GL11.glDisable(GL11.GL_CULL_FACE);
+        GLRenderer.disableState(State.CULL_FACE);
         float cameraY = (float) this.mc.activeCamera.getY(partialTick);
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorShader tessellator = GLRenderer.getTessellator();
         float cloudWidth = 12F;
         float cloudThickness = 4F;
         double dx = (this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F)) / (double) cloudWidth;
@@ -1061,8 +873,8 @@ public class RenderGlobal
         dx -= i * 2048;
         dz -= j * 2048;
         this.textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         float f13 = 1F / 256F;
         float f9 = (float) MathHelper.floor(dx) * f13;
         float f11 = (float) MathHelper.floor(dz) * f13;
@@ -1071,95 +883,100 @@ public class RenderGlobal
         int cloudWidthScale = 8;
         byte radius = 3;
         float f16 = 1F / 1024F;
-        GL11.glScalef(cloudWidth, 1.0F, cloudWidth);
+        GLRenderer.modelM4f().scale(cloudWidth, 1.0F, cloudWidth);
 
         float red = rDim + (rSun - rDim) * aSun;
         float green = gDim + (gSun - gDim) * aSun;
         float blue = bDim + (bSun - bDim) * aSun;
 
-        for (int l = 0; l < 2; l++) {
-            if (l == 0) {
-                GL11.glColorMask(false, false, false, true);
-            } else {
-                GL11.glColorMask(true, true, true, true);
+        tessellator.startDrawingQuads();
+        {
+            float width = (radius * 2 + 2) * cloudWidthScale;
+            float minX = (-radius - 1) * cloudWidthScale;
+            float minZ = (-radius - 1) * cloudWidthScale;
+            float cloudX = minX - f14;
+            float cloudZ = minZ - f15;
+            if (dy > -cloudThickness - 1.0F) {
+                tessellator.setColor4f(red * 0.7F, green * 0.7F, blue * 0.7F, 0.8F);
+                tessellator.setNormal(0.0F, -1F, 0.0F);
+                tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + width, (minX + 0.0F) * f13 + f9, (minZ + width) * f13 + f11);
+                tessellator.addVertexWithUV(cloudX + width, dy + 0.0F, cloudZ + width, (minX + width) * f13 + f9, (minZ + width) * f13 + f11);
+                tessellator.addVertexWithUV(cloudX + width, dy + 0.0F, cloudZ + 0.0F, (minX + width) * f13 + f9, (minZ + 0.0F) * f13 + f11);
+                tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + 0.0F, (minX + 0.0F) * f13 + f9, (minZ + 0.0F) * f13 + f11);
             }
-            tessellator.startDrawingQuads();
-            for (int ix = -radius - 1; ix <= radius; ix++) {
-                for (int iz = -radius - 1; iz <= radius; iz++) {
-
-                    float f17 = ix * cloudWidthScale;
-                    float f18 = iz * cloudWidthScale;
-                    float cloudX = f17 - f14;
-                    float cloudZ = f18 - f15;
-                    if (dy > -cloudThickness - 1.0F) {
-                        tessellator.setColorRGBA_F(red * 0.7F, green * 0.7F, blue * 0.7F, 0.8F);
-                        tessellator.setNormal(0.0F, -1F, 0.0F);
-                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + 0.0F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, cloudZ + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                    }
-                    if (dy <= cloudThickness + 1.0F) {
-                        tessellator.setColorRGBA_F(red, green, blue, 0.8F);
-                        tessellator.setNormal(0.0F, 1.0F, 0.0F);
-                        tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + (float) cloudWidthScale, (f17 + 0.0F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, (dy + cloudThickness) - f16, cloudZ + (float) cloudWidthScale, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, (dy + cloudThickness) - f16, cloudZ + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
+            if (dy <= cloudThickness + 1.0F) {
+                tessellator.setColor4f(red, green, blue, 0.8F);
+                tessellator.setNormal(0.0F, 1.0F, 0.0F);
+                tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + width, (minX + 0.0F) * f13 + f9, (minZ + width) * f13 + f11);
+                tessellator.addVertexWithUV(cloudX + width, (dy + cloudThickness) - f16, cloudZ + width, (minX + width) * f13 + f9, (minZ + width) * f13 + f11);
+                tessellator.addVertexWithUV(cloudX + width, (dy + cloudThickness) - f16, cloudZ + 0.0F, (minX + width) * f13 + f9, (minZ + 0.0F) * f13 + f11);
+                tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + 0.0F, (minX + 0.0F) * f13 + f9, (minZ + 0.0F) * f13 + f11);
+            }
+        }
+        for (int ix = -radius - 1; ix <= radius + 1; ix++) {
+            for (int iz = -radius - 1; iz <= radius + 1; iz++) {
+
+                float f17 = ix * cloudWidthScale;
+                float f18 = iz * cloudWidthScale;
+                float cloudX = f17 - f14;
+                float cloudZ = f18 - f15;
+                tessellator.setColor4f(red * 0.9F, green * 0.9F, blue * 0.9F, 0.8F);
+                if (ix > -1) {
+                    tessellator.setNormal(-1F, 0.0F, 0.0F);
+                    for (int k1 = 0; k1 < cloudWidthScale; k1++) {
+                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + cloudThickness, cloudZ + (float) cloudWidthScale, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + cloudThickness, cloudZ + 0.0F, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + 0.0F, cloudZ + 0.0F, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
                     }
-                    tessellator.setColorRGBA_F(red * 0.9F, green * 0.9F, blue * 0.9F, 0.8F);
-                    if (ix > -1) {
-                        tessellator.setNormal(-1F, 0.0F, 0.0F);
-                        for (int k1 = 0; k1 < cloudWidthScale; k1++) {
-                            tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + cloudThickness, cloudZ + (float) cloudWidthScale, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + cloudThickness, cloudZ + 0.0F, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + 0.0F, cloudZ + 0.0F, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                        }
 
+                } else {
+                    tessellator.setNormal(1.0F, 0.0F, 0.0F);
+                    for (int l1 = 0; l1 < cloudWidthScale; l1++) {
+                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
+                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + cloudThickness, cloudZ + (float) cloudWidthScale, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
+                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + cloudThickness, cloudZ + 0.0F, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
+                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + 0.0F, cloudZ + 0.0F, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
                     }
-                    if (ix <= 1) {
-                        tessellator.setNormal(1.0F, 0.0F, 0.0F);
-                        for (int l1 = 0; l1 < cloudWidthScale; l1++) {
-                            tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                            tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + cloudThickness, cloudZ + (float) cloudWidthScale, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                            tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + cloudThickness, cloudZ + 0.0F, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                            tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + 0.0F, cloudZ + 0.0F, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                        }
 
+                }
+                tessellator.setColor4f(red * 0.8F, green * 0.8F, blue * 0.8F, 0.8F);
+                if (iz > -1) {
+                    tessellator.setNormal(0.0F, 0.0F, -1F);
+                    for (int i2 = 0; i2 < cloudWidthScale; i2++) {
+                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + cloudThickness, cloudZ + (float) i2 + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + cloudThickness, cloudZ + (float) i2 + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, cloudZ + (float) i2 + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + (float) i2 + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
                     }
-                    tessellator.setColorRGBA_F(red * 0.8F, green * 0.8F, blue * 0.8F, 0.8F);
-                    if (iz > -1) {
-                        tessellator.setNormal(0.0F, 0.0F, -1F);
-                        for (int i2 = 0; i2 < cloudWidthScale; i2++) {
-                            tessellator.addVertexWithUV(cloudX + 0.0F, dy + cloudThickness, cloudZ + (float) i2 + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + cloudThickness, cloudZ + (float) i2 + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, cloudZ + (float) i2 + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + (float) i2 + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
-                        }
 
+                } else {
+                    tessellator.setNormal(0.0F, 0.0F, 1.0F);
+                    for (int j2 = 0; j2 < cloudWidthScale; j2++) {
+                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + cloudThickness, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + 0.0F) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + cloudThickness, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
+                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + 0.0F) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
                     }
-                    if (iz <= 1) {
-                        tessellator.setNormal(0.0F, 0.0F, 1.0F);
-                        for (int j2 = 0; j2 < cloudWidthScale; j2++) {
-                            tessellator.addVertexWithUV(cloudX + 0.0F, dy + cloudThickness, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + 0.0F) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + cloudThickness, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
-                            tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + 0.0F) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
-                        }
 
-                    }
                 }
-
             }
-            tessellator.draw();
 
         }
+        GLRenderer.setShader(Shaders.CLOUDS);
+        GLRenderer.setColorMask(false, false, false, true);
+        tessellator.draw();
+
+        // Hack for not needing to record the cloud buffer twice
+        GLRenderer.setColorMask(true, true, true, true);
+        GLRenderer.getShader().bind();
+        GL41.glBindVertexArray(tessellator.vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, tessellator.vbo);
+        GL41.glDrawArrays(tessellator.drawMode.cap, 0, tessellator.vertexCount);
+        GL41.glBindVertexArray(0);
 
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glEnable(GL11.GL_CULL_FACE);
 
+        GLRenderer.popFrame();
         this.mc.renderer.endRenderClouds(partialTick);
     }
 
@@ -1254,35 +1071,34 @@ public class RenderGlobal
     }
 
     public void drawBlockBreaking(@NotNull ICamera camera, @NotNull HitResult.Tile tileHit, float partialTick) {
-        Tessellator tessellator = Tessellator.instance;
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glEnable(GL11.GL_ALPHA_TEST);
-        GL11.glBlendFunc(770, 1);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float) System.currentTimeMillis() / 100F) * 0.2F + 0.4F) * 0.5F);
+        GLRenderer.pushFrame();
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        GLRenderer.enableState(State.BLEND);
+//        GL11.glEnable(GL11.GL_ALPHA_TEST);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float) System.currentTimeMillis() / 100F) * 0.2F + 0.4F) * 0.5F);
         if (this.destroyProgress > 0.0F) {
-            GL11.glBlendFunc(774, 768);
-            TextureRegistry.blockAtlas.bind();
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
-            GL11.glPushMatrix();
+            GLRenderer.setBlendFunc(BlendFactor.DST_COLOR, BlendFactor.SRC1_COLOR);
+            TextureRegistry.worldAtlas.bind();
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 0.5F);
+            GLRenderer.pushFrame();
             int k = this.world.getBlockId(tileHit.tilePos);
             Block<?> block = k <= 0 ? null : Blocks.blocksList[k];
-            GL11.glDisable(GL11.GL_ALPHA_TEST);
-            GL11.glPolygonOffset(-3F, -3F);
-            GL11.glEnable(GL_POLYGON_OFFSET_FILL);
+//            GL11.glDisable(GL11.GL_ALPHA_TEST);
+            GLRenderer.setPolygonOffset(-3F, -3F);
+            GLRenderer.enableState(State.POLYGON_OFFSET_FILL);
             double x = camera.getX(partialTick);
             double y = camera.getY(partialTick);
             double z = camera.getZ(partialTick);
             if (block == null) {
                 block = Blocks.STONE;
             }
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
+//            GL11.glEnable(GL11.GL_ALPHA_TEST);
             tessellator.startDrawingQuads();
             tessellator.setTranslation(-x, -y, -z);
             tessellator.lockColor();
-            if (LightmapHelper.isLightmapEnabled()) {
-                // Make sure it's active to prevent crash if a model doesnt enable it
-                tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
-            }
+            // Make sure it's active to prevent crash if a model doesnt enable it
+            tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 0));
             BlockModelDispatcher.getInstance()
                 .getDispatch(block)
                 .renderWithOverrideTexture(
@@ -1292,26 +1108,22 @@ public class RenderGlobal
                     breakingAnimation[MathHelper.clamp((int) (this.destroyProgress * 10F), 0, breakingAnimation.length - 1)]);
             tessellator.draw();
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-            GL11.glDisable(GL11.GL_ALPHA_TEST);
-            GL11.glPolygonOffset(0.0F, 0.0F);
-            GL11.glDisable(GL_POLYGON_OFFSET_FILL);
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
-            GL11.glDepthMask(true);
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDisable(GL11.GL_ALPHA_TEST);
+//        GL11.glDisable(GL11.GL_ALPHA_TEST);
+        GLRenderer.popFrame();
     }
 
     public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick) {
         if (this.mc.gameSettings.immersiveMode.drawOutline() && this.mc.gameSettings.blockOutlineWidth.value > 0.01f && !(this.mc.currentScreen instanceof ScreenModelViewer)) {
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+            GLRenderer.pushFrame();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             float w = this.mc.getOutlineWidth();
-            GL11.glColor4f(0.0F, 0.0F, 0.0F, 0.35f + w * 0.3f);
-            GL11.glLineWidth(java.lang.Math.max(4.0f * w * 2.0f, 1.0f));
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
-            GL11.glDepthMask(false);
+            GLRenderer.setColor4f(0.0F, 0.0F, 0.0F, 0.35f + w * 0.3f);
+            GLRenderer.setLineWidth(org.joml.Math.max(4.0f * w * 2.0f, 1.0f));
+            GLRenderer.setShader(Shaders.LINES);
+            GLRenderer.setDepthMask(false);
             double offsetX = camera.getX(partialTick);
             double offsetY = camera.getY(partialTick);
             double offsetZ = camera.getZ(partialTick);
@@ -1329,7 +1141,7 @@ public class RenderGlobal
                         drawOutlinedBoundingBox(selectionBB);
                     }
                     if (this.mc.gameSettings.viewSupportMode.value) {
-                        Tessellator t = Tessellator.instance;
+                        TessellatorGeneral t = GLRenderer.getTessellator();
 
                         double x = hitTile.tilePos.x() - offsetX;
                         double y = hitTile.tilePos.y() - offsetY;
@@ -1349,9 +1161,9 @@ public class RenderGlobal
 
                         {// Top
                             if (sTop.canSupport(PartialSupport.INSTANCE.center(), Side.BOTTOM)) {
-                                t.setColorRGBA_F(0f, 1f, 0f, 0.25f);
+                                t.setColor4f(0f, 1f, 0f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0f, 0.25f);
+                                t.setColor4f(1f, 0f, 0f, 0.25f);
                             }
                             t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
                             t.addVertex(x + oMin + 0.25, y + oMax, z + oMax - 0.25);
@@ -1359,9 +1171,9 @@ public class RenderGlobal
                             t.addVertex(x + oMax - 0.25, y + oMax, z + oMin + 0.25);
 
                             if (sTop.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM)) {
-                                t.setColorRGBA_F(0.5f, 1f, 0.5f, 0.25f);
+                                t.setColor4f(0.5f, 1f, 0.5f, 0.25f);
                             } else {
-                                t.setColorRGBA_F(1f, 0f, 0.5f, 0.25f);
+                                t.setColor4f(1f, 0f, 0.5f, 0.25f);
                             }
                             t.addVertex(x + oMin, y + oMax, z + oMin);
                             t.addVertex(x + oMin + 0.25, y + oMax, z + oMin + 0.25);
